## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# Generated by rust2rpm 18
%bcond_without check

%global crate libbpf-cargo

Name:           rust-%{crate}
Version:        0.9.3
Release:        %autorelease
Summary:        Cargo plugin to build bpf programs

# Upstream license specification: LGPL-2.1 OR BSD-2-Clause
License:        LGPLv2 or BSD
URL:            https://crates.io/crates/libbpf-cargo
Source:         %{crates_source}
# Turn on the novendor feature by default
Patch0:         libbpf-cargo-fix-metadata.diff
# Downgrade libbpf-sys to 0.4.0-2; this patch is meant for Fedora 35 and lower
# where libbpf is still at 0.4.0
Patch1:         libbpf-cargo-downgrade-libbpf-sys.patch

ExclusiveArch:  %{rust_arches}
%if %{__cargo_skip_build}
BuildArch:      noarch
%endif

BuildRequires:  rust-packaging
%if %{with check}
BuildRequires: clang
BuildRequires: rustfmt
%endif

%global _description %{expand:
Cargo plugin to build bpf programs.}

%description %{_description}

%if ! %{__cargo_skip_build}
%package     -n %{crate}
Summary:        %{summary}

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE LICENSE.BSD-2-Clause LICENSE.LPGL-2.1
%doc README.md
%{_bindir}/cargo-libbpf
%endif

%package        devel
Summary:        %{summary}
BuildArch:      noarch
Requires:       clang
Requires:       rustfmt

%description    devel %{_description}

This package contains library source intended for building other packages
which use "%{crate}" crate.

%files          devel
%license LICENSE LICENSE.BSD-2-Clause LICENSE.LPGL-2.1
%doc README.md
%{cargo_registry}/%{crate}-%{version_no_tilde}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages
which use "default" feature of "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+novendor-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+novendor-devel %{_description}

This package contains library source intended for building other packages
which use "novendor" feature of "%{crate}" crate.

%files       -n %{name}+novendor-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%prep
%setup -q -n %{crate}-%{version_no_tilde}
%patch0 -p1
%if 0%{?fedora} < 36
%patch1 -p1
%endif
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build

%install
%cargo_install

%if %{with check}
%check
# These tests don't work when run outside of the git repo
# https://github.com/libbpf/libbpf-rs/issues/107
%cargo_test -- -- --skip test_skeleton_basic --skip test_skeleton_builder_basic --skip test_skeleton_datasec --skip test_skeleton_empty_source
%endif

%changelog
* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 0.9.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Nov 11 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.9.3-1
- Update to 0.9.3; Fixes: RHBZ#2022162

* Mon Oct 25 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.9.2-2
- Downgrade libbpf-sys to 0.4.0-2 on Fedora 35 and earlier

* Thu Oct 14 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.9.2-1
- Update to 0.9.2; Fixes: RHBZ#1989691

* Fri Jul 30 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.8.1-1
- Update to 0.8.1; Fixes: RHBZ#1983186

* Thu Jul 29 2021 Davide Cavalca <dcavalca@fedoraproject.org> 0.7.2-4
- Workaround https://pagure.io/fedora-rust/rust2rpm/issue/138

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sat Jun 26 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.7.2-1
- Update to 0.7.2

* Wed Jun 16 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.7.1-2
- Add clang and rustfmt to Requires as they're runtime dependencies

* Thu Jun 03 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.7.1-1
- Update to 0.7.1
- Build for all architectures
- Enable tests by default and gate out the ones that don't work
- Backport PR#112 to bump libbpf-sys to 0.4.0-1

* Wed Jun 02 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 0.7.0-1
- Initial package

